#!/usr/bin/env python
# coding: utf-8

# In[1]:


import numpy as np


# In[5]:


A= np.array([
    [0,1,-3],
    [3,1,3],
    [2,1,1]
])
# teste ob der Vektor (2,-3,-1)^T im Kern von A liegt
A.dot(np.array([2,-3,-1]).T)


# In[6]:


# numpy kann uns direkt eine (näherungsweise) SVD geben (mit A=U Sigma V)
U, Sigma, V = np.linalg.svd(A)


# In[7]:


print("U = %s \n" %U)
print("Sigma = %s \n" %Sigma)
# hier sehen wir, dass die Berechnung immer fehlerhaft ist, denn A ist nicht invertierbar
#=> Sigma sollte auch nicht invertierbar sein
print("V = %s \n" %V)

U.dot(np.diag(Sigma)).dot(V)


# In[9]:


# wir berechnen die Pseudo-Inverse API=A^+.
#Per Hand korrigieren wir hier den Fehler, dass der letzte Singulärwert eigentlich 0 ist
API=V.T.dot(np.diag(np.array([1/Sigma[0],1/Sigma[1],0]))).dot(U.T)


# In[10]:


API


# In[12]:


#teste A^+ * A * A^+ = A^+
API.dot(A).dot(API)-API #ist nah genug an der 0


# In[13]:


#gleiches für A * A^+ * A =A
A.dot(API).dot(A)-A


# In[15]:


# wir wollen nun das LGS Ax=b betrachten
b=np.array([1,2,3]).T
b


# In[16]:


y=API.dot(b)
y


# In[17]:


# was ist der Fehler zum eigentlichen LGS
d=A.dot(y)-b
d


# In[18]:


#teste ob d orthogonal zum Bild => minimiere Problem ||Ax-b||
A.T.dot(d)


# In[19]:


#teste ob y orthogonal zum Kern von A: => minimiere ||y|| mit gleichem Bild
k= np.array([2,-3,-1])
k.T.dot(y)


# In[ ]:




